Module ij
Package ij.io

# Class Opener

java.lang.Object
ij.io.Opener

public class Opener extends Object
Opens tiff (and tiff stacks), dicom, fits, pgm, jpeg, bmp or gif images, and look-up tables, using a file open dialog or a path. Calls HandleExtraFileTypes plugin if the file type is unrecognised.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`AVI`
`static final int`
`BMP`
`static final int`
`CUSTOM`
`static final int`
`DICOM`
`static final int`
`FITS`
`static final int`
`GIF`
`static final int`
`JAVA_OR_TEXT`
`static final int`
`JPEG`
`static final int`
`LUT`
`static final int`
`OJJ`
`static final int`
`PGM`
`static final int`
`PNG`
`static final int`
`RAW`
`static final int`
`ROI`
`static final int`
`TABLE`
`static final int`
`TEXT`
`static final int`
`TIFF`
`static final int`
`TIFF_AND_DICOM`
`static final String[]`
`types`
`static final int`
`UNKNOWN`
`static final int`
`ZIP`

## Constructor Summary

Constructors
Constructor
Description
`Opener()`

## Method Summary

Modifier and Type
Method
Description
`static void`
`convertGrayJpegTo8Bits(ImagePlus imp)`
Converts the specified RGB image to 8-bits if the 3 channels are identical.
`ImagePlus`
`deserialize(byte[] bytes)`
Deserialize a byte array that was serialized using the FileSaver.serialize().
`String`
`getDir(String path)`
`static String`
`getFileFormat(String path)`
`int`
`getFileType(String path)`
Attempts to determine the image file type by looking for 'magic numbers' and the file name extension.
`static String`
`getLoadRate(double time, ImagePlus imp)`
`String`
`getName(String path)`
`static boolean`
`getOpenUsingPlugins()`
Returns the state of the openUsingPlugins flag.
`static FileInfo[]`
`getTiffFileInfo(String path)`
Returns the FileInfo of the specified TIFF file.
`static boolean`
`isFullPath(String path)`
`static String`
`makeFullPath(String path)`
`void`
`open()`
Displays a file open dialog box and then opens the tiff, dicom, fits, pgm, jpeg, bmp, gif, lut, roi, or text file selected by the user.
`void`
`open(String path)`
Opens and displays the specified tiff, dicom, fits, pgm, jpeg, bmp, gif, lut, roi, or text file.
`boolean`
`openAndAddToRecent(String path)`
Opens the specified file and adds it to the File/Open Recent menu.
`ImagePlus`
`openImage(String path)`
Opens, but does not display, the specified image file and returns an ImagePlus object object if successful, or returns null if the file is not in a supported format or is not found.
`ImagePlus`
`openImage(String path, int n)`
Open the nth image of the specified tiff stack.
`ImagePlus`
`openImage(String directory, String name)`
Attempts to open the specified file as a tiff, bmp, dicom, fits, pgm, gif or jpeg image.
`static LUT`
`openLut(String filePathOrUrl)`
Opens a lookup table (LUT) and returns it as a LUT object, or returns null if there is an error.
`void`
`openMultiple()`
Displays a JFileChooser and then opens the tiff, dicom, fits, pgm, jpeg, bmp, gif, lut, roi, or text files selected by the user.
`static void`
`openResultsTable(String path)`
Opens a tab or comma delimited text file in the Results window.
`Roi`
`openRoi(String path)`
Attempts to open the specified ROI, returning null if unsuccessful.
`static void`
`openTable(String path)`
Opens a tab or comma delimited text file.
`ImagePlus`
`openTempImage(String directory, String name)`
`ImagePlus`
`openTextImage(String dir, String name)`
Opens the specified text file as a float image.
`ImagePlus`
`openTiff(InputStream in, String name)`
Attempts to open the specified inputStream as a TIFF, returning an ImagePlus object if successful.
`ImagePlus`
`openTiff(String path, int n)`
Opens the nth image of the specified TIFF stack.
`ImagePlus`
`openTiff(String directory, String name)`
Attempts to open the specified file as a tiff.
`ImagePlus`
`openTiffStack(FileInfo[] info)`
Attemps to open a tiff file as a stack.
`ImagePlus`
`openURL(String url)`
Attempts to open the specified url as a tiff, zip compressed tiff, dicom, gif or jpeg.
`static ImagePlus`
`openUsingBioFormats(String path)`
Opens an image file using the Bio-Formats plugin.
`static ImagePlus`
`openUsingImageIO(String path)`
`ImagePlus`
`openWithHandleExtraFileTypes(String path, int[] fileTypes)`
`ImagePlus`
`openZip(String path)`
Opens a single TIFF or DICOM contained in a ZIP archive, or a ZIPed collection of ".roi" files created by the ROI manager.
`static void`
`setOpenUsingPlugins(boolean b)`
Open all images using HandleExtraFileTypes.
`void`
`setSilentMode(boolean mode)`
The "Opening: path" status message is not displayed in silent mode.
`static String`
`updateUrl(String url)`
Can't open imagej.nih.gov URLs due to encryption so redirect to imagej.net mirror.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### UNKNOWN

public static final int UNKNOWN

See Also:
  - Constant Field Values

### TIFF

public static final int TIFF

See Also:
  - Constant Field Values

### DICOM

public static final int DICOM

See Also:
  - Constant Field Values

### FITS

public static final int FITS

See Also:
  - Constant Field Values

### PGM

public static final int PGM

See Also:
  - Constant Field Values

### JPEG

public static final int JPEG

See Also:
  - Constant Field Values

### GIF

public static final int GIF

See Also:
  - Constant Field Values

### LUT

public static final int LUT

See Also:
  - Constant Field Values

### BMP

public static final int BMP

See Also:
  - Constant Field Values

### ZIP

public static final int ZIP

See Also:
  - Constant Field Values

### JAVA_OR_TEXT

public static final int JAVA_OR_TEXT

See Also:
  - Constant Field Values

### ROI

public static final int ROI

See Also:
  - Constant Field Values

### TEXT

public static final int TEXT

See Also:
  - Constant Field Values

### PNG

public static final int PNG

See Also:
  - Constant Field Values

### TIFF_AND_DICOM

public static final int TIFF_AND_DICOM

See Also:
  - Constant Field Values

### CUSTOM

public static final int CUSTOM

See Also:
  - Constant Field Values

### AVI

public static final int AVI

See Also:
  - Constant Field Values

### OJJ

public static final int OJJ

See Also:
  - Constant Field Values

### TABLE

public static final int TABLE

See Also:
  - Constant Field Values

### RAW

public static final int RAW

See Also:
  - Constant Field Values

### types

public static final String[] types

## Constructor Details

### Opener

public Opener()

## Method Details

### open

public void open()
Displays a file open dialog box and then opens the tiff, dicom, fits, pgm, jpeg, bmp, gif, lut, roi, or text file selected by the user. Displays an error message if the selected file is not in a supported format. This is the method that ImageJ's File/Open command uses to open files.

See Also:
  - `IJ.open()`
  - `IJ.open(String)`
  - `IJ.openImage(java.lang.String)`
  - `IJ.openImage(String)`

### open

public void open(String path)
Opens and displays the specified tiff, dicom, fits, pgm, jpeg, bmp, gif, lut, roi, or text file. Displays an error message if the file is not in a supported format.

See Also:
  - `IJ.open(String)`
  - `IJ.openImage(String)`

### openMultiple

public void openMultiple()
Displays a JFileChooser and then opens the tiff, dicom, fits, pgm, jpeg, bmp, gif, lut, roi, or text files selected by the user. Displays error messages if one or more of the selected files is not in one of the supported formats. This is the method that ImageJ's File/Open command uses to open files if "Open/Save Using JFileChooser" is checked in EditOptions/Misc.

### openImage

public ImagePlus openImage(String path)
Opens, but does not display, the specified image file and returns an ImagePlus object object if successful, or returns null if the file is not in a supported format or is not found. Displays a file open dialog if 'path' is null or an empty string.

See Also:
  - `IJ.openImage(String)`
  - `IJ.openImage(java.lang.String)`
  - `openUsingBioFormats(java.lang.String)`

### openImage

public ImagePlus openImage(String path, int n)
Open the nth image of the specified tiff stack.

See Also:
  - `IJ.openImage(String,int)`

### getLoadRate

public static String getLoadRate(double time, ImagePlus imp)

### makeFullPath

public static String makeFullPath(String path)

### isFullPath

public static boolean isFullPath(String path)

### openAndAddToRecent

public boolean openAndAddToRecent(String path)
Opens the specified file and adds it to the File/Open Recent menu. Returns true if the file was opened successfully.

### openImage

public ImagePlus openImage(String directory, String name)
Attempts to open the specified file as a tiff, bmp, dicom, fits, pgm, gif or jpeg image. Returns an ImagePlus object if successful. Modified by Gregory Jefferis to call HandleExtraFileTypes plugin if the file type is unrecognised.

See Also:
  - `IJ.openImage(String)`

### openTempImage

public ImagePlus openTempImage(String directory, String name)

### openTextImage

public ImagePlus openTextImage(String dir, String name)
Opens the specified text file as a float image.

### openURL

public ImagePlus openURL(String url)
Attempts to open the specified url as a tiff, zip compressed tiff, dicom, gif or jpeg. Tiff file names must end in ".tif", ZIP file names must end in ".zip" and dicom file names must end in ".dcm". Returns an ImagePlus object if successful.

See Also:
  - `IJ.openImage(String)`

### updateUrl

public static String updateUrl(String url)
Can't open imagej.nih.gov URLs due to encryption so redirect to imagej.net mirror.

### openWithHandleExtraFileTypes

public ImagePlus openWithHandleExtraFileTypes(String path, int[] fileTypes)

### openUsingImageIO

public static ImagePlus openUsingImageIO(String path)

### convertGrayJpegTo8Bits

public static void convertGrayJpegTo8Bits(ImagePlus imp)
Converts the specified RGB image to 8-bits if the 3 channels are identical.

### openTiffStack

public ImagePlus openTiffStack(FileInfo[] info)
Attemps to open a tiff file as a stack. Returns an ImagePlus object if successful.

### openTiff

public ImagePlus openTiff(String directory, String name)
Attempts to open the specified file as a tiff. Returns an ImagePlus object if successful.

### openTiff

public ImagePlus openTiff(String path, int n)
Opens the nth image of the specified TIFF stack.

### getTiffFileInfo

public static FileInfo[] getTiffFileInfo(String path)
Returns the FileInfo of the specified TIFF file.

### openTiff

public ImagePlus openTiff(InputStream in, String name)
Attempts to open the specified inputStream as a TIFF, returning an ImagePlus object if successful.

### openZip

public ImagePlus openZip(String path)
Opens a single TIFF or DICOM contained in a ZIP archive, or a ZIPed collection of ".roi" files created by the ROI manager.

### deserialize

public ImagePlus deserialize(byte[] bytes)
Deserialize a byte array that was serialized using the FileSaver.serialize().

### getName

public String getName(String path)

### getDir

public String getDir(String path)

### openRoi

public Roi openRoi(String path)
Attempts to open the specified ROI, returning null if unsuccessful.

### openUsingBioFormats

public static ImagePlus openUsingBioFormats(String path)
Opens an image file using the Bio-Formats plugin.

### openLut

public static LUT openLut(String filePathOrUrl)
Opens a lookup table (LUT) and returns it as a LUT object, or returns null if there is an error.

See Also:
  - `ImagePlus.setLut(ij.process.LUT)`

### openResultsTable

public static void openResultsTable(String path)
Opens a tab or comma delimited text file in the Results window.

### openTable

public static void openTable(String path)
Opens a tab or comma delimited text file.

### getFileFormat

public static String getFileFormat(String path)

### getFileType

public int getFileType(String path)
Attempts to determine the image file type by looking for 'magic numbers' and the file name extension.

### setSilentMode

public void setSilentMode(boolean mode)
The "Opening: path" status message is not displayed in silent mode.

### setOpenUsingPlugins

public static void setOpenUsingPlugins(boolean b)
Open all images using HandleExtraFileTypes. Set from a macro using setOption("openUsingPlugins", true).

### getOpenUsingPlugins

public static boolean getOpenUsingPlugins()
Returns the state of the openUsingPlugins flag.